#include "cgi-com-path.h"
#include "cgi-search.h"
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


/*
*    Generates url, title and file lists and their indexes.
*
*    Copyright (c) 2020, 2021 R.J. van der Putten, Leiden, Holland, 
*    rob at sput dot nl.
* 
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License version 3 as
*    published by the Free Software Foundation.
* 
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*/


/*  Use files in current dir  */
//#define CGS_DO_TEST 1


int main(int argc, char **argv)
{
	char line[4096], *str;
	char inam[CGS_PATH_SIZ], outnam[CGS_PATH_SIZ], idxnam[CGS_PATH_SIZ];
	int len;
	unsigned int u;
	FILE *infil, *outfil, *idxfil;
	struct stridx strindex;

	len  = 0;
	u = 0;
	memset(line,   0, 4096);
	memset(inam,   0, CGS_PATH_SIZ);
	memset(outnam, 0, CGS_PATH_SIZ);
	memset(idxnam, 0, CGS_PATH_SIZ);
	memset(&strindex, 0, sizeof(strindex));
	infil  = NULL;
	outfil = NULL;
	idxfil = NULL;

	str = line + 5;

	if (argc != 2) {
		fprintf(stderr, "Usage: gen-num-index file.\n");
		exit(1);
	}

	/*  Files names  */
	#ifdef CGS_DO_TEST
	 /*  Max filename length is 255 bytes  */
	 snprintf(inam,   255, "num-%s.list", argv[1]);
	 snprintf(outnam, 255, "%s-list", argv[1]);
	 snprintf(idxnam, 255, "%s.idx", argv[1]);
	#else
	 snprintf(inam,   CGS_PATH_MAX, "num-%s.list", argv[1]);
	 snprintf(outnam, CGS_PATH_MAX, "%s/new/%s-list", CGS_PATH, argv[1]);
	 snprintf(idxnam, CGS_PATH_MAX, "%s/new/%s.idx", CGS_PATH, argv[1]);
	#endif

	if ((infil = fopen(inam, "r")) == NULL) {
		fprintf(stderr, "Cant open %s.\n", inam);
		exit(1);
	}
	if ((outfil = fopen(outnam, "w")) == NULL) {
		fprintf(stderr, "Cant open %s.\n", outnam);
		fclose(infil);
		exit(1);
	}
	if ((idxfil = fopen(idxnam, "w")) == NULL) {
		fprintf(stderr, "Cant open %s.\n", idxnam);
		fclose(infil);
		fclose(outfil);
		exit(1);
	}

	while (fgets(line, 4096, infil)) {
		/*  XXXX String  */
		len = strlen(line) - 1;
		if (line[len] == 10) {
			line[len] = 0;
			len--;
		}
		if(line[0] == 0)
			continue;
		if (line[len] == 13) {
			line[len] = 0;
			len--;
		}
		len++;
		if(len < 6)
			continue;

		line[4] = 0;
		if (sscanf(line, "%4X", &u) != 1) {
			fprintf(stderr, "scanf() failed.\n");
			fclose(idxfil);
			fclose(outfil);
			fclose(infil);
			exit(1);
		}
		strindex.num = (int) u;
		strindex.len = len - 5;
		/* size_t fwrite(const void *ptr, size_t size, size_t nmemb, FILE *stream); */
		fwrite(str, 1, len - 4, outfil);
		fwrite(&strindex, sizeof(strindex), 1, idxfil);
		strindex.ptr = strindex.ptr + len - 4;	/*  Next  */
	}

	fclose(idxfil);
	fclose(outfil);
	fclose(infil);

	return(0);
}

